Index: /palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4723)
+++ /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4724)
@@ -967,5 +1258,5 @@
 !> layer. 
 !------------------------------------------------------------------------------!
-    SUBROUTINE nesting_offl_bc                     
+    SUBROUTINE nesting_offl_bc
 
        USE exchange_horiz_mod,                                                    &
@@ -976,5 +1267,5 @@
        INTEGER(iwp) ::  k !< running index z-direction
        INTEGER(iwp) ::  n !< running index for chemical species
-       
+
        REAL(wp), DIMENSION(nzb:nzt+1) ::  pt_ref   !< reference profile for potential temperature
        REAL(wp), DIMENSION(nzb:nzt+1) ::  pt_ref_l !< reference profile for potential temperature on subdomain
@@ -985,4 +1276,5 @@
        REAL(wp), DIMENSION(nzb:nzt+1) ::  v_ref    !< reference profile for v-component
        REAL(wp), DIMENSION(nzb:nzt+1) ::  v_ref_l  !< reference profile for v-component on subdomain
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  var_1d   !< pre-interpolated profile for LOD1 mode
 
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ref_chem   !< reference profile for chemical species
@@ -991,7 +1283,7 @@
        IF ( debug_output_timestep )  CALL debug_message( 'nesting_offl_bc', 'start' )
 
-       CALL  cpu_log( log_point(58), 'offline nesting', 'start' )      
-!
-!--    Initialize mean profiles, derived from boundary data, to zero
+       CALL  cpu_log( log_point(58), 'offline nesting', 'start' )
+!
+!--    Initialize mean profiles, derived from boundary data, to zero.
        pt_ref   = 0.0_wp
        q_ref    = 0.0_wp
@@ -1020,78 +1312,164 @@
 !--    boundary_conditions() to restore prognostic values.
 !--    Further, sum up data to calculate mean profiles from boundary data, 
-!--    used for Rayleigh damping. 
-       IF ( bc_dirichlet_l )  THEN
-
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                u(k,j,0) = interpolate_in_time( nest_offl%u_left(0,k,j),       &
-                                                nest_offl%u_left(1,k,j),       &
-                                                fac_dt ) *                     &
-                             MERGE( 1.0_wp, 0.0_wp,                            &
-                                    BTEST( wall_flags_total_0(k,j,0), 1 ) )
-                u(k,j,-1) = u(k,j,0)
-             ENDDO
-             u_ref_l(nzb+1:nzt) = u_ref_l(nzb+1:nzt) + u(nzb+1:nzt,j,0)
-          ENDDO
-
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt-1
-                w(k,j,-1) = interpolate_in_time( nest_offl%w_left(0,k,j),      &
-                                                 nest_offl%w_left(1,k,j),      &
-                                                 fac_dt ) *                    &
-                            MERGE( 1.0_wp, 0.0_wp,                             &
-                                   BTEST( wall_flags_total_0(k,j,-1), 3 ) )
-             ENDDO
-             w(nzt,j,-1) = w(nzt-1,j,-1)
-          ENDDO
-
-          DO  j = nysv, nyn
-             DO  k = nzb+1, nzt
-                v(k,j,-1) = interpolate_in_time( nest_offl%v_left(0,k,j),      &
-                                                 nest_offl%v_left(1,k,j),      &
-                                                 fac_dt ) *                    &
-                               MERGE( 1.0_wp, 0.0_wp,                          &
-                                      BTEST( wall_flags_total_0(k,j,-1), 2 ) )
-             ENDDO
-             v_ref_l(nzb+1:nzt) = v_ref_l(nzb+1:nzt) + v(nzb+1:nzt,j,-1)
-          ENDDO
-
-          IF ( .NOT. neutral )  THEN
+!--    used for Rayleigh damping.
+       IF ( bc_dirichlet_l  )  THEN
+!
+!--       u-component
+          IF ( lod == 2 )  THEN
              DO  j = nys, nyn
                 DO  k = nzb+1, nzt
-                   pt(k,j,-1) = interpolate_in_time( nest_offl%pt_left(0,k,j), &
-                                                     nest_offl%pt_left(1,k,j), &
-                                                     fac_dt )
- 
-                ENDDO
-                pt_ref_l(nzb+1:nzt) = pt_ref_l(nzb+1:nzt) + pt(nzb+1:nzt,j,-1)
-             ENDDO
-          ENDIF
-
+                   u(k,j,i_bound_u) = interpolate_in_time( nest_offl%u_l(0,k,j),                   &
+                                                           nest_offl%u_l(1,k,j),                   &
+                                                           fac_dt ) *                              &
+                                      MERGE( 1.0_wp, 0.0_wp,                                       &
+                                             BTEST( wall_flags_total_0(k,j,i_bound_u), 1 ) )
+                ENDDO
+                u(:,j,i_bound_u-1) = u(:,j,i_bound_u)
+                u_ref_l(nzb+1:nzt) = u_ref_l(nzb+1:nzt) + u(nzb+1:nzt,j,i_bound_u)
+             ENDDO
+          ELSE
+!
+!--          Pre-interpolate profile before mapping onto the boundaries.
+             DO  k = nzb+1, nzt
+                var_1d(k) = interpolate_in_time( nest_offl%u_l(0,k,1),                             &
+                                                 nest_offl%u_l(1,k,1),                             &
+                                                 fac_dt )
+             ENDDO
+             DO  j = nys, nyn
+                u(nzb+1:nzt,j,i_bound_u) = var_1d(nzb+1:nzt) *                                     &
+                                     MERGE( 1.0_wp, 0.0_wp,                                        &
+                                            BTEST( wall_flags_total_0(nzb+1:nzt,j,i_bound_u), 1 ) )
+                u(:,j,i_bound_u-1) = u(:,j,i_bound_u)
+                u_ref_l(nzb+1:nzt) = u_ref_l(nzb+1:nzt) + u(nzb+1:nzt,j,i_bound_u)
+             ENDDO
+          ENDIF
+!
+!--       w-component
+          IF ( lod == 2 )  THEN
+             DO  j = nys, nyn
+                DO  k = nzb+1, nzt-1
+                   w(k,j,i_bound) = interpolate_in_time( nest_offl%w_l(0,k,j),                     &
+                                                         nest_offl%w_l(1,k,j),                     &
+                                                         fac_dt ) *                                &
+                                    MERGE( 1.0_wp, 0.0_wp,                                         &
+                                           BTEST( wall_flags_total_0(k,j,i_bound), 3 ) )
+                ENDDO
+                w(nzt,j,i_bound) = w(nzt-1,j,i_bound)
+             ENDDO
+          ELSE
+             DO  k = nzb+1, nzt-1
+                var_1d(k) = interpolate_in_time( nest_offl%w_l(0,k,1),                             &
+                                                 nest_offl%w_l(1,k,1),                             &
+                                                 fac_dt )
+             ENDDO
+             DO  j = nys, nyn
+                w(nzb+1:nzt-1,j,i_bound) = var_1d(nzb+1:nzt-1) *                                   &
+                                      MERGE( 1.0_wp, 0.0_wp,                                       &
+                                             BTEST( wall_flags_total_0(nzb+1:nzt-1,j,i_bound), 3 ) )
+                w(nzt,j,i_bound) = w(nzt-1,j,i_bound)
+             ENDDO
+          ENDIF
+!
+!--       v-component
+          IF ( lod == 2 )  THEN
+             DO  j = nysv, nyn
+                DO  k = nzb+1, nzt
+                   v(k,j,i_bound) = interpolate_in_time( nest_offl%v_l(0,k,j),                     &
+                                                         nest_offl%v_l(1,k,j),                     &
+                                                         fac_dt ) *                                &
+                                    MERGE( 1.0_wp, 0.0_wp,                                         &
+                                           BTEST( wall_flags_total_0(k,j,i_bound), 2 ) )
+                ENDDO
+                v_ref_l(nzb+1:nzt) = v_ref_l(nzb+1:nzt) + v(nzb+1:nzt,j,i_bound)
+             ENDDO
+          ELSE
+             DO  k = nzb+1, nzt
+                var_1d(k) = interpolate_in_time( nest_offl%v_l(0,k,1),                             &
+                                                 nest_offl%v_l(1,k,1),                             &
+                                                 fac_dt )
+             ENDDO
+             DO  j = nysv, nyn
+                v(nzb+1:nzt,j,i_bound) = var_1d(nzb+1:nzt) *                                       &
+                                      MERGE( 1.0_wp, 0.0_wp,                                       &
+                                             BTEST( wall_flags_total_0(nzb+1:nzt,j,i_bound), 2 ) )
+                v_ref_l(nzb+1:nzt) = v_ref_l(nzb+1:nzt) + v(nzb+1:nzt,j,i_bound)
+             ENDDO
+          ENDIF
+!
+!--       potential temperature
+          IF ( .NOT. neutral )  THEN
+             IF ( lod == 2 )  THEN
+                DO  j = nys, nyn
+                   DO  k = nzb+1, nzt
+                      pt(k,j,i_bound) = interpolate_in_time( nest_offl%pt_l(0,k,j),                &
+                                                             nest_offl%pt_l(1,k,j),                &
+                                                             fac_dt )
+                   ENDDO
+                   pt_ref_l(nzb+1:nzt) = pt_ref_l(nzb+1:nzt) + pt(nzb+1:nzt,j,i_bound)
+                ENDDO
+             ELSE
+                DO  k = nzb+1, nzt
+                   var_1d(k) = interpolate_in_time( nest_offl%pt_l(0,k,1),                         &
+                                                    nest_offl%pt_l(1,k,1),                         &
+                                                    fac_dt )
+                ENDDO
+                DO  j = nys, nyn
+                   pt(nzb+1:nzt,j,i_bound) = var_1d(nzb+1:nzt)
+                   pt_ref_l(nzb+1:nzt)     = pt_ref_l(nzb+1:nzt) + pt(nzb+1:nzt,j,i_bound)
+                ENDDO
+             ENDIF
+          ENDIF
+!
+!--       humidity
           IF ( humidity )  THEN
-             DO  j = nys, nyn
+             IF ( lod == 2 )  THEN
+                DO  j = nys, nyn
+                   DO  k = nzb+1, nzt
+                      q(k,j,i_bound) = interpolate_in_time( nest_offl%q_l(0,k,j),                  &
+                                                            nest_offl%q_l(1,k,j),                  &
+                                                            fac_dt )
+                   ENDDO
+                   q_ref_l(nzb+1:nzt) = q_ref_l(nzb+1:nzt) + q(nzb+1:nzt,j,i_bound)
+                ENDDO
+             ELSE
                 DO  k = nzb+1, nzt
-                   q(k,j,-1) = interpolate_in_time( nest_offl%q_left(0,k,j),   &
-                                                    nest_offl%q_left(1,k,j),   &
+                   var_1d(k) = interpolate_in_time( nest_offl%q_l(0,k,1),                          &
+                                                    nest_offl%q_l(1,k,1),                          &
                                                     fac_dt )
- 
-                ENDDO
-                q_ref_l(nzb+1:nzt) = q_ref_l(nzb+1:nzt) + q(nzb+1:nzt,j,-1)
-             ENDDO
-          ENDIF
-
+                ENDDO
+                DO  j = nys, nyn
+                   q(nzb+1:nzt,j,i_bound) = var_1d(nzb+1:nzt)
+                   q_ref_l(nzb+1:nzt)     = q_ref_l(nzb+1:nzt) + q(nzb+1:nzt,j,i_bound)
+                ENDDO
+             ENDIF
+          ENDIF
+!
+!--       chemistry
           IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
              DO  n = 1, UBOUND( chem_species, 1 )
                 IF ( nest_offl%chem_from_file_l(n) )  THEN
-                   DO  j = nys, nyn
+                   IF ( lod == 2 )  THEN
+                      DO  j = nys, nyn
+                         DO  k = nzb+1, nzt
+                            chem_species(n)%conc(k,j,i_bound) = interpolate_in_time(               &
+                                                                        nest_offl%chem_l(0,k,j,n), &
+                                                                        nest_offl%chem_l(1,k,j,n), &
+                                                                        fac_dt                   )
+                         ENDDO
+                         ref_chem_l(nzb+1:nzt,n) = ref_chem_l(nzb+1:nzt,n)                         &
+                                            + chem_species(n)%conc(nzb+1:nzt,j,i_bound)
+                      ENDDO
+                   ELSE
                       DO  k = nzb+1, nzt
-                         chem_species(n)%conc(k,j,-1) = interpolate_in_time(   &
-                                                  nest_offl%chem_left(0,k,j,n),&
-                                                  nest_offl%chem_left(1,k,j,n),&
-                                                  fac_dt                   )
+                         var_1d(k) = interpolate_in_time( nest_offl%chem_l(0,k,1,n),               &
+                                                          nest_offl%chem_l(1,k,1,n),               &
+                                                          fac_dt )
                       ENDDO
-                      ref_chem_l(nzb+1:nzt,n) = ref_chem_l(nzb+1:nzt,n)        &
-                                         + chem_species(n)%conc(nzb+1:nzt,j,-1)
-                   ENDDO
+                      DO  j = nys, nyn
+                         chem_species(n)%conc(nzb+1:nzt,j,i_bound) = var_1d(nzb+1:nzt)
+                         ref_chem_l(nzb+1:nzt,n) = ref_chem_l(nzb+1:nzt,n)                         &
+                                                 + chem_species(n)%conc(nzb+1:nzt,j,i_bound)
+                      ENDDO
+                   ENDIF
                 ENDIF
              ENDDO
@@ -1100,76 +1478,159 @@
        ENDIF
 
-       IF ( bc_dirichlet_r )  THEN
-
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                u(k,j,nxr+1) = interpolate_in_time( nest_offl%u_right(0,k,j),  &
-                                                    nest_offl%u_right(1,k,j),  &
-                                                    fac_dt ) *                 &
-                             MERGE( 1.0_wp, 0.0_wp,                            &
-                                    BTEST( wall_flags_total_0(k,j,nxr+1), 1 ) )
-             ENDDO
-             u_ref_l(nzb+1:nzt) = u_ref_l(nzb+1:nzt) + u(nzb+1:nzt,j,nxr+1)
-          ENDDO
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt-1
-                w(k,j,nxr+1) = interpolate_in_time( nest_offl%w_right(0,k,j),  &
-                                                    nest_offl%w_right(1,k,j),  &
-                                                    fac_dt ) *                 &
-                             MERGE( 1.0_wp, 0.0_wp,                            &
-                                    BTEST( wall_flags_total_0(k,j,nxr+1), 3 ) )
-             ENDDO
-             w(nzt,j,nxr+1) = w(nzt-1,j,nxr+1)
-          ENDDO
-
-          DO  j = nysv, nyn
-             DO  k = nzb+1, nzt
-                v(k,j,nxr+1) = interpolate_in_time( nest_offl%v_right(0,k,j),  &
-                                                    nest_offl%v_right(1,k,j),  &
-                                                    fac_dt ) *                 &
-                             MERGE( 1.0_wp, 0.0_wp,                            &
-                                    BTEST( wall_flags_total_0(k,j,nxr+1), 2 ) )
-             ENDDO
-             v_ref_l(nzb+1:nzt) = v_ref_l(nzb+1:nzt) + v(nzb+1:nzt,j,nxr+1)
-          ENDDO
-
-          IF ( .NOT. neutral )  THEN
+       IF ( bc_dirichlet_r  )  THEN
+!
+!--       u-component
+          IF ( lod == 2 )  THEN
              DO  j = nys, nyn
                 DO  k = nzb+1, nzt
-                   pt(k,j,nxr+1) = interpolate_in_time(                        &
-                                                  nest_offl%pt_right(0,k,j),   &
-                                                  nest_offl%pt_right(1,k,j),   &
-                                                  fac_dt )
-                ENDDO
-                pt_ref_l(nzb+1:nzt) = pt_ref_l(nzb+1:nzt) + pt(nzb+1:nzt,j,nxr+1)
-             ENDDO
-          ENDIF
-
+                   u(k,j,i_bound_u) = interpolate_in_time( nest_offl%u_r(0,k,j),                   &
+                                                           nest_offl%u_r(1,k,j),                   &
+                                                           fac_dt ) *                              &
+                                      MERGE( 1.0_wp, 0.0_wp,                                       &
+                                             BTEST( wall_flags_total_0(k,j,i_bound_u), 1 ) )
+                ENDDO
+                u_ref_l(nzb+1:nzt) = u_ref_l(nzb+1:nzt) + u(nzb+1:nzt,j,i_bound_u)
+             ENDDO
+          ELSE
+             DO  k = nzb+1, nzt
+                var_1d(k) = interpolate_in_time( nest_offl%u_r(0,k,1),                             &
+                                                 nest_offl%u_r(1,k,1),                             &
+                                                 fac_dt )
+             ENDDO
+             DO  j = nys, nyn
+                u(nzb+1:nzt,j,i_bound_u) = var_1d(nzb+1:nzt) *                                     &
+                                      MERGE( 1.0_wp, 0.0_wp,                                       &
+                                             BTEST( wall_flags_total_0(nzb+1:nzt,j,i_bound_u), 1 ) )
+                u_ref_l(nzb+1:nzt)       = u_ref_l(nzb+1:nzt) + u(nzb+1:nzt,j,i_bound_u)
+             ENDDO
+          ENDIF
+!
+!--       w-component
+          IF ( lod == 2 )  THEN
+             DO  j = nys, nyn
+                DO  k = nzb+1, nzt-1
+                   w(k,j,i_bound) = interpolate_in_time( nest_offl%w_r(0,k,j),                     &
+                                                         nest_offl%w_r(1,k,j),                     &
+                                                         fac_dt ) *                                &
+                                    MERGE( 1.0_wp, 0.0_wp,                                         &
+                                           BTEST( wall_flags_total_0(k,j,i_bound), 3 ) )
+                ENDDO
+                w(nzt,j,i_bound) = w(nzt-1,j,i_bound)
+             ENDDO
+          ELSE
+             DO  k = nzb+1, nzt-1
+                var_1d(k) = interpolate_in_time( nest_offl%w_r(0,k,1),                             &
+                                                 nest_offl%w_r(1,k,1),                             &
+                                                 fac_dt )
+             ENDDO
+             DO  j = nys, nyn
+                w(nzb+1:nzt-1,j,i_bound) = var_1d(nzb+1:nzt-1) *                                   &
+                                     MERGE( 1.0_wp, 0.0_wp,                                        &
+                                            BTEST( wall_flags_total_0(nzb+1:nzt-1,j,i_bound), 3 ) )
+                w(nzt,j,i_bound) = w(nzt-1,j,i_bound)
+             ENDDO
+          ENDIF
+!
+!--       v-component
+          IF ( lod == 2 )  THEN
+             DO  j = nysv, nyn
+                DO  k = nzb+1, nzt
+                   v(k,j,i_bound) = interpolate_in_time( nest_offl%v_r(0,k,j),                     &
+                                                         nest_offl%v_r(1,k,j),                     &
+                                                         fac_dt ) *                                &
+                                    MERGE( 1.0_wp, 0.0_wp,                                         &
+                                           BTEST( wall_flags_total_0(k,j,i_bound), 2 ) )
+                ENDDO
+                v_ref_l(nzb+1:nzt) = v_ref_l(nzb+1:nzt) + v(nzb+1:nzt,j,i_bound)
+             ENDDO
+          ELSE
+             DO  k = nzb+1, nzt
+                var_1d(k) = interpolate_in_time( nest_offl%v_r(0,k,1),                             &
+                                                 nest_offl%v_r(1,k,1),                             &
+                                                 fac_dt )
+             ENDDO
+             DO  j = nysv, nyn
+                v(nzb+1:nzt,j,i_bound) = var_1d(nzb+1:nzt) *                                       &
+                                       MERGE( 1.0_wp, 0.0_wp,                                      &
+                                              BTEST( wall_flags_total_0(nzb+1:nzt,j,i_bound), 2 ) )
+                v_ref_l(nzb+1:nzt)     = v_ref_l(nzb+1:nzt) + v(nzb+1:nzt,j,i_bound)
+             ENDDO
+          ENDIF
+!
+!--       potential temperature
+          IF ( .NOT. neutral )  THEN
+             IF ( lod == 2 )  THEN
+                DO  j = nys, nyn
+                   DO  k = nzb+1, nzt
+                      pt(k,j,i_bound) = interpolate_in_time( nest_offl%pt_r(0,k,j),                &
+                                                             nest_offl%pt_r(1,k,j),                &
+                                                             fac_dt )
+                   ENDDO
+                   pt_ref_l(nzb+1:nzt) = pt_ref_l(nzb+1:nzt) + pt(nzb+1:nzt,j,i_bound)
+                ENDDO
+             ELSE
+                DO  k = nzb+1, nzt
+                   var_1d(k) = interpolate_in_time( nest_offl%pt_r(0,k,1),                         &
+                                                    nest_offl%pt_r(1,k,1),                         &
+                                                    fac_dt )
+                ENDDO
+                DO  j = nys, nyn
+                   pt(nzb+1:nzt,j,i_bound) = var_1d(nzb+1:nzt)
+                   pt_ref_l(nzb+1:nzt)     = pt_ref_l(nzb+1:nzt) + pt(nzb+1:nzt,j,i_bound)
+                ENDDO
+             ENDIF
+          ENDIF
+!
+!--       humidity
           IF ( humidity )  THEN
-             DO  j = nys, nyn
+             IF ( lod == 2 )  THEN
+                DO  j = nys, nyn
+                   DO  k = nzb+1, nzt
+                      q(k,j,i_bound) = interpolate_in_time( nest_offl%q_r(0,k,j),                  &
+                                                            nest_offl%q_r(1,k,j),                  &
+                                                            fac_dt )
+                   ENDDO
+                   q_ref_l(nzb+1:nzt) = q_ref_l(nzb+1:nzt) + q(nzb+1:nzt,j,i_bound)
+                ENDDO
+             ELSE
                 DO  k = nzb+1, nzt
-                   q(k,j,nxr+1) = interpolate_in_time(                         &
-                                                  nest_offl%q_right(0,k,j),    &
-                                                  nest_offl%q_right(1,k,j),    &
-                                                  fac_dt ) 
- 
-                ENDDO
-                q_ref_l(nzb+1:nzt) = q_ref_l(nzb+1:nzt) + q(nzb+1:nzt,j,nxr+1)
-             ENDDO
-          ENDIF
-
+                   var_1d(k) = interpolate_in_time( nest_offl%q_r(0,k,1),                          &
+                                                    nest_offl%q_r(1,k,1),                          &
+                                                    fac_dt )
+                ENDDO
+                DO  j = nys, nyn
+                   q(nzb+1:nzt,j,i_bound) = var_1d(nzb+1:nzt)
+                   q_ref_l(nzb+1:nzt)     = q_ref_l(nzb+1:nzt) + q(nzb+1:nzt,j,i_bound)
+                ENDDO
+             ENDIF
+          ENDIF
+!
+!--       chemistry
           IF ( air_chemistry  .AND.  nesting_offline_chem )  THEN
              DO  n = 1, UBOUND( chem_species, 1 )
                 IF ( nest_offl%chem_from_file_r(n) )  THEN
-                   DO  j = nys, nyn
+                   IF ( lod == 2 )  THEN
+                      DO  j = nys, nyn
+                         DO  k = nzb+1, nzt
+                            chem_species(n)%conc(k,j,i_bound) = interpolate_in_time(               &
+                                                                        nest_offl%chem_r(0,k,j,n), &
+                                                                        nest_offl%chem_r(1,k,j,n), &
+                                                                        fac_dt                   )
+                         ENDDO
+                         ref_chem_l(nzb+1:nzt,n) = ref_chem_l(nzb+1:nzt,n)                         &
+                                            + chem_species(n)%conc(nzb+1:nzt,j,i_bound)
+                      ENDDO
+                   ELSE
                       DO  k = nzb+1, nzt
-                         chem_species(n)%conc(k,j,nxr+1) = interpolate_in_time(&
-                                                 nest_offl%chem_right(0,k,j,n),&
-                                                 nest_offl%chem_right(1,k,j,n),&
-                                                 fac_dt                       )
+                         var_1d(k) = interpolate_in_time( nest_offl%chem_r(0,k,1,n),               &
+                                                          nest_offl%chem_r(1,k,1,n),               &
+                                                          fac_dt )
                       ENDDO
-                      ref_chem_l(nzb+1:nzt,n) = ref_chem_l(nzb+1:nzt,n)        &
-                                       + chem_species(n)%conc(nzb+1:nzt,j,nxr+1)
-                   ENDDO
+                      DO  j = nys, nyn
+                         chem_species(n)%conc(nzb+1:nzt,j,i_bound) = var_1d(nzb+1:nzt)
+                         ref_chem_l(nzb+1:nzt,n) = ref_chem_l(nzb+1:nzt,n)                         &
+                                                 + chem_species(n)%conc(nzb+1:nzt,j,i_bound)
+                      ENDDO
+                   ENDIF
                 ENDIF
              ENDDO
